#include <fstream>

#include <awali/dyn.hh>

using namespace awali::dyn;

int main(int argc, char **argv) {
  if(argc!=2){
    std::cerr << "Usage : " << argv[0] << " [file]" << std::endl;
    return 1;
  }
  //Open a json description of an automaton
  //std::ifstream file(argv[1]);
  automaton_t aut = load(argv[1]);
  
  std::cout << "Output the automaton in json format to file `out.json`" 
            << std::endl;
  save(aut,"out.json");

  std::cout << "Output the automaton in json format to file `out.grail`"
            << std::endl;
  save(aut,"out.grail","grail");
  
  std::cout << "Output the automaton in dot format to file `out.gv`" 
            << std::endl;
  save(aut,"out.gv","dot");

  std::cout << "Output the automaton in pdf format (image) to `out.pdf`" 
            << std::endl;
  save(aut,"out.pdf","pdf");

  return 0;
}
