#include <fstream>

#include <awali/dyn.hh>

using namespace awali::dyn;

int main(int argc, char **argv) {
  if(argc!=2){
    std::cerr << "Usage : " << argv[0] << " [file]" << std::endl;
    return 1;
  }
  //Open a json description of an automaton
  std::ifstream file(argv[1]);
  automaton_t aut;
  file >> aut;
  /* other available syntaxes:
    file >> io::json >> aut;
    aut=parse_automaton(file);

    It is also possible to load fado or grail automata, e.g.
    file >> io::fado >> aut;  or aut=fado(file);
  */
  file.close();
  std::cout << "Print the automaton (json)" << std::endl;
  std::cout << aut << std::endl;
  //or std::cout << io::json << aut << std::endl;
  //or json(aut, std::cout) << std::endl;
  std::cout << "Print the automaton (dot)" << std::endl;
  std::cout << io::dot << aut << std::endl;
  //or dot(aut, std::cout) << std::endl;
  std::cout << "Print the automaton (fado)" << std::endl;
  std::cout << io::fado << aut << std::endl;
  //or fado(aut, std::cout) << std::endl;
  std::cout << "Print the automaton (grail)" << std::endl;
  std::cout << io::grail << aut << std::endl;
  //or grail(aut, std::cout) << std::endl;
  std::cout << "Print the automaton as a pdf image" << std::endl;
  std::cout << io::pdf << aut << std::endl;
  //or grail(aut, std::cout) << std::endl;
  return 0;
}
