#ifndef DYN_FACTORIES_HH
#define DYN_FACTORIES_HH

#include <awali/dyn/core/automaton.hh>
#include <awali/dyn/loading/handler.hh>
#include <vector>

namespace awali { namespace dyn {

  //(a+b)*a(a+b){n}
  automaton_t de_bruijn(unsigned n, char first_letter='a');
  automaton_t divkbaseb(unsigned k, unsigned b, char first_letter='a');
  automaton_t double_ring(unsigned n, const std::vector<unsigned>& finals, char first_letter='a');
  automaton_t ladybird(unsigned n, char first_letter='a');
  automaton_t cerny(unsigned n, char first_letter='a');

  //Brzozowski universal witness
  automaton_t witness(unsigned n, char first_letter='a');


}}//end of ns awali::dyn

#endif
