#include <awali/dyn/modules/graph.hh>

#include <awali/dyn/loading/handler.hh>

namespace awali { namespace dyn {

  std::pair< std::unordered_map<state_t, unsigned int>,
            std::vector<std::vector<state_t>> >
  scc_recursive (automaton_t aut)
  {
    return loading::call<
          std::pair< std::unordered_map<state_t, unsigned int>,
                    std::vector<std::vector<state_t>> >,
          &scc_recursive  >
      ("scc_recursive", "graph", aut);
  }


  std::pair< std::unordered_map<state_t, unsigned int>,
  std::vector<std::vector<state_t>> >
  scc_iterative (automaton_t aut)
  {
    return loading::call<
            std::pair< std::unordered_map<state_t, unsigned int>,
                      std::vector<std::vector<state_t>> >,
            &scc_iterative  >
        ("scc_iterative", "graph", aut);
  }


  std::pair<  automaton_t,
              std::pair< std::unordered_map<state_t, unsigned int>,
                         std::vector<std::vector<state_t>> >  >
  condensation (automaton_t aut)
  {
    return loading::call<
          std::pair< automaton_t,
                     std::pair< std::unordered_map<state_t, unsigned int>,
                                std::vector<std::vector<state_t>> > >,
    &condensation  >
    ("condensation", "graph", aut);
  }

  std::vector<state_t>
  scc_of (automaton_t aut, state_t stt)
  {
    return loading::call2< std::vector<state_t>, state_t, &scc_of >
          ("scc_of", "graph", aut, stt);
  }

}}//end of ns awali::dyn
