#ifndef DYN_MODULES_HISTORY_CC
#define DYN_MODULES_HISTORY_CC

#include <awali/dyn/core/automaton.hh>
#include <awali/dyn/loading/handler.hh>

#include <awali/dyn/modules/history.hh>

namespace awali { namespace dyn {

  history_kind_t get_history_kind(automaton_t aut) {
    return loading::call<history_kind_t, &get_history_kind>("get_history_kind", "history", aut);
  }

  //For SINGLE
  state_t get_origin_state(automaton_t aut, state_t s) {
    return loading::call2<state_t, state_t, &get_origin_state>("get_origin_state", "history", aut,s);
  }

  //For PARTITION and TUPLE
  std::vector<state_t> get_origin_states(automaton_t aut, state_t s) {
    return loading::call2<std::vector<state_t>, state_t, &get_origin_states>("get_origin_states", "history", aut,s);
  }

}}//end of ns awali::dyn


#endif
