#ifndef DYN_MODULES_RATEXP_HH
#define DYN_MODULES_RATEXP_HH

#include <iostream>
#include <set>
#include <unordered_map>
#include <awali/dyn/core/abstract-ratexp.hh>
#include <awali/dyn/loading/handler.hh>
#include <awali/dyn/core/context-description.hh>

namespace awali {
  namespace dyn {

    ratexp_t make_ratexp(const std::string& exp, const std::string& sr);
    ratexp_t make_ratexp(const std::string& exp);

    ratexp_t aut_to_exp(automaton_t aut);
    automaton_t lift(automaton_t aut);
    ratexp_t expand(ratexp_t exp);
    ratexp_t star_normal_form(ratexp_t exp);
    unsigned star_height(ratexp_t exp);
    bool is_valid(ratexp_t exp);
    weight_t constant_term(ratexp_t exp);
    
  }
}//end of ns awali::dyn

#endif
