#ifndef DYN_MODULES_STANDARD_HH
#define DYN_MODULES_STANDARD_HH

#include <iostream>
#include <unordered_map>
#include <awali/dyn/core/automaton.hh>
#include <awali/dyn/core/abstract-ratexp.hh>
#include <awali/dyn/loading/handler.hh>

namespace awali {
  namespace dyn {

    bool is_standard(automaton_t aut);
    automaton_t standard(automaton_t aut);
    void standard_here(automaton_t aut);
    automaton_t standard(ratexp_t exp);

    automaton_t concatenate(automaton_t aut, automaton_t aut2);
    void concatenate_here(automaton_t aut, automaton_t aut2);

    automaton_t sum(automaton_t aut, automaton_t aut2);
    void sum_here(automaton_t aut, automaton_t aut2);

    automaton_t star(automaton_t aut);
    void star_here(automaton_t aut);

  }
}//end of ns awali::dyn

#endif
