#include <awali/dyn.hh>
#include <awali/dyn/loading/locations.hh>
#include<fstream>
#include<cassert>

using namespace awali::dyn;

int main() {
  automaton_t a = ladybird(8);
  automaton_t d = determinize(a);
  assert(!is_deterministic(a));
  assert(is_deterministic(d));
  assert(are_equivalent(a, d));
  assert(!is_complete(d));
  automaton_t cp = complete(d);
  assert(is_complete(cp));
  automaton_t cpt = complement(cp);
  automaton_t inter = product(a,cpt);
  trim_here(inter);
  assert(is_empty(inter));
  automaton_t trp = transpose(d);
  assert(!is_ambiguous(trp));
  complete_here(d);
  assert(is_complete(d));
  complement_here(d);
  inter = product(a,d);
  trim_here(inter);
  assert(is_empty(inter));

//   std::ifstream

  automaton_t b1 = load("b1", "json");
//   file.close();
  automaton_t b6 = power(b1, 6);
  automaton_t r6 = reduce(b6);
  assert(r6->num_states() == 7);
  r6 = min_quotient(b6);
  assert(r6->num_states() == 7);
  r6 = min_quotient(b6);
  return 0;
}
