#include <vector>
#include <cassert>

#include <awali/dyn.hh>

using namespace awali::dyn;

int main() {
  automaton_t a = ladybird(12);
  automaton_t d = determinize(a);
  automaton_t m = min_quotient(d);
  assert(d->num_states() == (1<<12)-1);
  assert(m->num_states() == (1<<12)-1);
  m = min_coquotient(d);
  assert(m->num_states() == (1<<12)-1);
  m = minimal_automaton(a);
  assert(m->num_states() == (1<<12));

  a = divkbaseb(6,2);
  std::vector<std::vector<unsigned int>> eq_class= {{3,6},{4,7}};
  m = quotient(a, eq_class);
  assert(m->num_states() == 4);
  //quotient is also tested with reduce in test-determinize
}
