#ifndef AWALI_ALGOS_IS_NORMALIZED_HH
# define AWALI_ALGOS_IS_NORMALIZED_HH

#include <awali/sttc/core/mutable-automaton.hh>

namespace awali { namespace sttc {

  template <typename Aut>
  bool
  is_normalized(const Aut& a)
  {
    return
      a->num_initials() == 1
      && a->weightset()->is_one(a->weight_of(a->initial_transitions().front()))
      && a->num_finals() == 1
      && a->weightset()->is_one(a->weight_of(a->final_transitions().front()))
      // No arrival on the initial state.
      && a->in(a->dst_of(a->initial_transitions().front())).empty()
      // No departure from the final state.
      && a->out(a->src_of(a->final_transitions().front())).empty();
  }
}}//end of ns awali::stc

#endif // !AWALI_ALGOS_IS_NORMALIZED_HH
