#ifndef AWALI_NO_HISTORY_HH
# define AWALI_NO_HISTORY_HH

#include <awali/sttc/history/history.hh>

namespace awali { namespace sttc {

    class no_history : public history_base {
    public:

      std::ostream&
      print_state_name(state_t s, std::ostream& o,
                       const std::string& fmt) const {
	return o;
      }


      history_kind_t get_nature() const {
	return history_kind_t::NO_HISTORY;
      }

      bool has_history(state_t s) const {
	return false;
      }

      bool remove_history(state_t s) {
	return false;
      };


      bool has_history() {
	return false;
      }

      state_t get_state(state_t s) {
	throw std::runtime_error("Origin state not available");
      }

      std::vector<state_t> get_state_set(state_t s) {
	throw std::runtime_error("Origin state set not available");
      }
    };
  }
}//end of ns awali::stc

#endif // !AWALI_NO_HISTORY_HH
